set(CTEST_SITE "localhost")
set(CTEST_BUILD_NAME "subproject_coverage_example")
set(CTEST_CMAKE_GENERATOR "Unix Makefiles")
set(CTEST_COVERAGE_COMMAND "gcov")
set(COVERAGE_OPTIONS
  "-DCMAKE_BUILD_TYPE=Debug"
  "-DCMAKE_CXX_FLAGS=-g -O0 --coverage"
  "-DCMAKE_C_FLAGS=-g -O0 --coverage"
  "-DCMAKE_EXE_LINKER_FLAGS=--coverage"
  "-DCMAKE_SHARED_LINKER_FLAGS=--coverage"
)

set(subprojects MyThirdPartyDependency MyExperimentalFeature MyProductionCode)

foreach(subproject ${subprojects})
  set(CTEST_SOURCE_DIRECTORY ${CTEST_SCRIPT_DIRECTORY}/src/${subproject})
  set(CTEST_BINARY_DIRECTORY ${CTEST_SCRIPT_DIRECTORY}/bin/${subproject})

  set_property(GLOBAL PROPERTY SubProject ${subproject})
  set_property(GLOBAL PROPERTY Label ${subproject})

  ctest_empty_binary_directory("${CTEST_BINARY_DIRECTORY}")

  ctest_start(Experimental)
  ctest_configure(OPTIONS "${COVERAGE_OPTIONS}")
  ctest_build()
  ctest_test()
  ctest_coverage()
  ctest_submit()
endforeach()
